static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xA5, 0x04, 0x30, 0x5C, 0x31, 0xC3, 0x4A, 0x84, 0x54, 0xB0,
        0xCF, 0xF0, 0xD3, 0xA2, 0xD0, 0xAA, 0xBE, 0x60, 0xF3, 0x9B,
        0xF7, 0xFD, 0xA9, 0xAD, 0xBD, 0x32, 0xD1, 0xE7, 0x84, 0xBC,
        0x18, 0xF2, 0x97, 0x35, 0x7F, 0x0D, 0xDD, 0x61, 0x06, 0x83,
        0xCB, 0x20, 0x16, 0xF0, 0x72, 0x2F, 0x4C, 0x18, 0x7A, 0x57,
        0x3F, 0x54, 0xB6, 0xAE, 0x81, 0x14, 0xF8, 0x21, 0xAD, 0x8E,
        0xE4, 0xC4, 0xF4, 0xF3
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
